LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;   

ENTITY bascule_jk IS
PORT( K, clk, J : IN STD_LOGIC;
	Q : INOUT STD_LOGIC;
	nQ : OUT STD_LOGIC);
END ENTITY;

ARCHITECTURE comp OF bascule_jk IS 
	SUBTYPE selecteur IS STD_LOGIC_VECTOR(1 DOWNTO 0);
BEGIN
	nQ <= NOT Q;
	PROCESS(clk)
	BEGIN
	IF RISING_EDGE(clk) THEN
		CASE selecteur'(J,K) IS
			WHEN "01" => Q <= '0';
			WHEN "10" => Q <= '1';
			WHEN "11" => Q <= NOT Q;
			WHEN OTHERS => Q <= Q;
		END CASE;
	END IF;
	END PROCESS;
END ARCHITECTURE comp;



